#include "beremiz.h"
#ifndef __POUS_H
#define __POUS_H

#include "accessor.h"
#include "iec_std_lib.h"

__DECLARE_ENUMERATED_TYPE(LOGLEVEL,
  LOGLEVEL__CRITICAL,
  LOGLEVEL__WARNING,
  LOGLEVEL__INFO,
  LOGLEVEL__DEBUG
)
// FUNCTION_BLOCK LOGGER
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,TRIG)
  __DECLARE_VAR(STRING,MSG)
  __DECLARE_VAR(LOGLEVEL,LEVEL)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(BOOL,TRIG0)

} LOGGER;

void LOGGER_init__(LOGGER *data__, BOOL retain);
// Code part
void LOGGER_body__(LOGGER *data__);
// FUNCTION_BLOCK PYTHON_EVAL
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,TRIG)
  __DECLARE_VAR(STRING,CODE)
  __DECLARE_VAR(BOOL,ACK)
  __DECLARE_VAR(STRING,RESULT)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(DWORD,STATE)
  __DECLARE_VAR(STRING,BUFFER)
  __DECLARE_VAR(STRING,PREBUFFER)
  __DECLARE_VAR(BOOL,TRIGM1)
  __DECLARE_VAR(BOOL,TRIGGED)

} PYTHON_EVAL;

void PYTHON_EVAL_init__(PYTHON_EVAL *data__, BOOL retain);
// Code part
void PYTHON_EVAL_body__(PYTHON_EVAL *data__);
// FUNCTION_BLOCK PYTHON_POLL
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(BOOL,TRIG)
  __DECLARE_VAR(STRING,CODE)
  __DECLARE_VAR(BOOL,ACK)
  __DECLARE_VAR(STRING,RESULT)

  // FB private variables - TEMP, private and located variables
  __DECLARE_VAR(DWORD,STATE)
  __DECLARE_VAR(STRING,BUFFER)
  __DECLARE_VAR(STRING,PREBUFFER)
  __DECLARE_VAR(BOOL,TRIGM1)
  __DECLARE_VAR(BOOL,TRIGGED)

} PYTHON_POLL;

void PYTHON_POLL_init__(PYTHON_POLL *data__, BOOL retain);
// Code part
void PYTHON_POLL_body__(PYTHON_POLL *data__);
// FUNCTION_BLOCK PYTHON_GEAR
// Data part
typedef struct {
  // FB Interface - IN, OUT, IN_OUT variables
  __DECLARE_VAR(BOOL,EN)
  __DECLARE_VAR(BOOL,ENO)
  __DECLARE_VAR(UINT,N)
  __DECLARE_VAR(BOOL,TRIG)
  __DECLARE_VAR(STRING,CODE)
  __DECLARE_VAR(BOOL,ACK)
  __DECLARE_VAR(STRING,RESULT)

  // FB private variables - TEMP, private and located variables
  PYTHON_EVAL PY_EVAL;
  __DECLARE_VAR(UINT,COUNTER)
  __DECLARE_VAR(UINT,ADD10_OUT)
  __DECLARE_VAR(BOOL,EQ13_OUT)
  __DECLARE_VAR(UINT,SEL15_OUT)
  __DECLARE_VAR(BOOL,AND7_OUT)

} PYTHON_GEAR;

void PYTHON_GEAR_init__(PYTHON_GEAR *data__, BOOL retain);
// Code part
void PYTHON_GEAR_body__(PYTHON_GEAR *data__);
// PROGRAM PROGRAM0
// Data part
typedef struct {
  // PROGRAM Interface - IN, OUT, IN_OUT variables

  // PROGRAM private variables - TEMP, private and located variables
  __DECLARE_VAR(BOOL,LSL_010)
  __DECLARE_VAR(BOOL,LSL_010_ED)
  __DECLARE_VAR(BOOL,LSH_010)
  __DECLARE_VAR(BOOL,LSH_010_ED)
  __DECLARE_VAR(BOOL,LSL_040)
  __DECLARE_VAR(BOOL,LSL_040_ED)
  __DECLARE_VAR(BOOL,LSH_040)
  __DECLARE_VAR(BOOL,LSH_040_ED)
  __DECLARE_VAR(BOOL,AGA_ONOFF)
  __DECLARE_VAR(BOOL,AGA_ONOFF_SD)
  __DECLARE_VAR(BOOL,AGL_ONOFF)
  __DECLARE_VAR(BOOL,AGL_ONOFF_SD)
  __DECLARE_VAR(BOOL,BCA_ONOFF)
  __DECLARE_VAR(BOOL,BCA_ONOFF_SD)
  __DECLARE_VAR(REAL,LT_010)
  __DECLARE_VAR(UINT,LT_010_EA)
  __DECLARE_VAR(REAL,TT_020A)
  __DECLARE_VAR(UINT,TT_020A_EA)
  __DECLARE_VAR(REAL,TT_020B)
  __DECLARE_VAR(UINT,TT_020B_EA)
  __DECLARE_VAR(REAL,FT_030)
  __DECLARE_VAR(UINT,FT_30_EA)
  __DECLARE_VAR(REAL,LT_040)
  __DECLARE_VAR(UINT,LT_40_EA)
  __DECLARE_VAR(REAL,TT_050A)
  __DECLARE_VAR(UINT,TT_050A_EA)
  __DECLARE_VAR(REAL,TT_050B)
  __DECLARE_VAR(UINT,TT_050B_EA)
  __DECLARE_VAR(REAL,TT_050C)
  __DECLARE_VAR(UINT,TT_050C_EA)
  __DECLARE_VAR(REAL,FT_060)
  __DECLARE_VAR(UINT,FT_060_EA)
  __DECLARE_VAR(REAL,TT_070)
  __DECLARE_VAR(UINT,TT_070_EA)
  __DECLARE_VAR(REAL,PT_080)
  __DECLARE_VAR(UINT,PT_080_EA)
  __DECLARE_VAR(REAL,FT_090)
  __DECLARE_VAR(UINT,FT_090_EA)
  __DECLARE_VAR(REAL,AQC_POT)
  __DECLARE_VAR(UINT,AQC_POT_SA)
  __DECLARE_VAR(REAL,BCA_VEL)
  __DECLARE_VAR(UINT,BCA_VEL_SA)
  __DECLARE_VAR(REAL,VAL_POS)
  __DECLARE_VAR(UINT,VAL_POS_SA)
  __DECLARE_VAR(UINT,MOVE47_OUT)
  __DECLARE_VAR(UINT,MOVE50_OUT)
  __DECLARE_VAR(UINT,MOVE53_OUT)
  __DECLARE_VAR(REAL,UINT_TO_REAL30_OUT)
  __DECLARE_VAR(REAL,SUB31_OUT)
  __DECLARE_VAR(REAL,DIV33_OUT)
  __DECLARE_VAR(REAL,MOVE3_OUT)
  __DECLARE_VAR(REAL,UINT_TO_REAL9_OUT)
  __DECLARE_VAR(REAL,SUB10_OUT)
  __DECLARE_VAR(REAL,DIV18_OUT)
  __DECLARE_VAR(REAL,MOVE8_OUT)

} PROGRAM0;

void PROGRAM0_init__(PROGRAM0 *data__, BOOL retain);
// Code part
void PROGRAM0_body__(PROGRAM0 *data__);
#endif //__POUS_H
