TYPE
  LOGLEVEL : (CRITICAL, WARNING, INFO, DEBUG) := INFO;
END_TYPE

FUNCTION_BLOCK LOGGER
  VAR_INPUT
    TRIG : BOOL;
    MSG : STRING;
    LEVEL : LOGLEVEL := INFO;
  END_VAR
  VAR
    TRIG0 : BOOL;
  END_VAR

  IF TRIG AND NOT TRIG0 THEN
  {{
   LogMessage(GetFbVar(LEVEL),(char*)GetFbVar(MSG, .body),GetFbVar(MSG, .len));
  }}
  END_IF;
  TRIG0:=TRIG;
END_FUNCTION_BLOCK



FUNCTION_BLOCK python_eval
  VAR_INPUT
    TRIG : BOOL;
    CODE : STRING;
  END_VAR
  VAR_OUTPUT
    ACK : BOOL;
    RESULT : STRING;
  END_VAR
  VAR
    STATE : DWORD;
    BUFFER : STRING;
    PREBUFFER : STRING;
    TRIGM1 : BOOL;
    TRIGGED : BOOL;
  END_VAR

  {extern void __PythonEvalFB(int, PYTHON_EVAL*);__PythonEvalFB(0, data__);}
END_FUNCTION_BLOCK

FUNCTION_BLOCK python_poll
  VAR_INPUT
    TRIG : BOOL;
    CODE : STRING;
  END_VAR
  VAR_OUTPUT
    ACK : BOOL;
    RESULT : STRING;
  END_VAR
  VAR
    STATE : DWORD;
    BUFFER : STRING;
    PREBUFFER : STRING;
    TRIGM1 : BOOL;
    TRIGGED : BOOL;
  END_VAR

  {extern void __PythonEvalFB(int, PYTHON_EVAL*);__PythonEvalFB(1,(PYTHON_EVAL*)(void*)data__);}
END_FUNCTION_BLOCK

FUNCTION_BLOCK python_gear
  VAR_INPUT
    N : UINT;
    TRIG : BOOL;
    CODE : STRING;
  END_VAR
  VAR_OUTPUT
    ACK : BOOL;
    RESULT : STRING;
  END_VAR
  VAR
    py_eval : python_eval;
    COUNTER : UINT;
    ADD10_OUT : UINT;
    EQ13_OUT : BOOL;
    SEL15_OUT : UINT;
    AND7_OUT : BOOL;
  END_VAR

  ADD10_OUT := ADD(COUNTER, 1);
  EQ13_OUT := EQ(N, ADD10_OUT);
  SEL15_OUT := SEL(EQ13_OUT, ADD10_OUT, 0);
  COUNTER := SEL15_OUT;
  AND7_OUT := AND(EQ13_OUT, TRIG);
  py_eval(TRIG := AND7_OUT, CODE := CODE);
  ACK := py_eval.ACK;
  RESULT := py_eval.RESULT;
END_FUNCTION_BLOCK


PROGRAM program0
  VAR
    LSL_010 : BOOL := 0;
    LSL_010_ED : BOOL := 0;
    LSH_010 : BOOL := 0;
    LSH_010_ED : BOOL := 0;
    LSL_040 : BOOL := 0;
    LSL_040_ED : BOOL := 0;
    LSH_040 : BOOL := 0;
    LSH_040_ED : BOOL := 0;
    AGA_OnOff : BOOL := 1;
    AGA_OnOff_SD : BOOL := 1;
    AGL_OnOff : BOOL := 1;
    AGL_OnOff_SD : BOOL := 1;
    BCA_OnOff : BOOL := 1;
    BCA_OnOff_SD : BOOL := 1;
    LT_010 : REAL := 6.0;
    LT_010_EA : UINT := 39321;
    TT_020a : REAL := 40.0;
    TT_020a_EA : UINT := 26214;
    TT_020b : REAL := 46.35;
    TT_020b_EA : UINT := 30375;
    FT_030 : REAL := 50.09;
    FT_30_EA : UINT := 8207;
    LT_040 : REAL := 3.5;
    LT_40_EA : UINT := 45874;
    TT_050a : REAL := 80.0;
    TT_050a_EA : UINT := 52428;
    TT_050b : REAL := 82.85;
    TT_050b_EA : UINT := 54295;
    TT_050c : REAL := 70.0;
    TT_050c_EA : UINT := 45874;
    FT_060 : REAL := 50.0;
    FT_060_EA : UINT := 8192;
    TT_070 : REAL := 20.0;
    TT_070_EA : UINT := 13107;
    PT_080 : REAL := 0.10;
    PT_080_EA : UINT := 6553;
    FT_090 : REAL := 130.4;
    FT_090_EA : UINT := 28485;
    AQC_Pot : REAL := 80.0;
    AQC_Pot_SA : UINT := 52428;
    BCA_Vel : REAL := 50.0;
    BCA_Vel_SA : UINT := 32767;
    VAL_Pos : REAL := 50.0;
    VAL_Pos_SA : UINT := 32767;
  END_VAR
  VAR
    MOVE47_OUT : UINT;
    MOVE50_OUT : UINT;
    MOVE53_OUT : UINT;
    UINT_TO_REAL30_OUT : REAL;
    SUB31_OUT : REAL;
    DIV33_OUT : REAL;
    MOVE3_OUT : REAL;
    UINT_TO_REAL9_OUT : REAL;
    SUB10_OUT : REAL;
    DIV18_OUT : REAL;
    MOVE8_OUT : REAL;
  END_VAR

  AGA_OnOff_SD := TRUE;
  AGL_OnOff_SD := TRUE;
  BCA_OnOff_SD := TRUE;
  MOVE47_OUT := MOVE(52428);
  AQC_Pot_SA := MOVE47_OUT;
  MOVE50_OUT := MOVE(32767);
  BCA_Vel_SA := MOVE50_OUT;
  MOVE53_OUT := MOVE(32767);
  VAL_Pos_SA := MOVE53_OUT;
  LSH_010 := LSH_010_ED;
  AGA_OnOff := AGA_OnOff_SD;
  UINT_TO_REAL30_OUT := UINT_TO_REAL(LT_010_EA);
  SUB31_OUT := SUB(UINT_TO_REAL30_OUT, 0.0);
  DIV33_OUT := DIV(SUB31_OUT, 6553.5);
  MOVE3_OUT := MOVE(DIV33_OUT);
  LT_010 := MOVE3_OUT;
  UINT_TO_REAL9_OUT := UINT_TO_REAL(AQC_Pot_SA);
  SUB10_OUT := SUB(UINT_TO_REAL9_OUT, 0.0);
  DIV18_OUT := DIV(SUB10_OUT, 655.35);
  MOVE8_OUT := MOVE(DIV18_OUT);
  AQC_Pot := MOVE8_OUT;
END_PROGRAM


CONFIGURATION Config0

  RESOURCE Res0 ON PLC
    TASK task0(INTERVAL := T#20ms,PRIORITY := 0);
    PROGRAM instance0 WITH task0 : program0;
  END_RESOURCE
END_CONFIGURATION
